////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.MKB;

public class LocalCondition extends Object
{
    private String myAttribute;
    private String myOperator;
    private String myValue;
    private double mySelectivity;

    public LocalCondition()
    {
        myAttribute = null;
        myValue = null;
    }

    public LocalCondition(String Attribute, String operator, 
                          String Value, double Selectivity)
    {
        myAttribute = Attribute;
        myOperator = operator;
        myValue = Value;
        mySelectivity = Selectivity;
    }

    public void setAttribute(String Attribute)
    {
        myAttribute = Attribute;
    }

    public void setOperator(String operator)
    {
        myOperator = operator;
    }

    public void setValue(String Value)
    {
        myValue = Value;
    }

    public String getAttribute()
    {
        return myAttribute;
    }

    public String getValue()
    {
        return myValue;
    }

    public String getOperator()
    {
        return myOperator;
    }

    public double getSelectivity()
    {
        return mySelectivity;
    }

    public String getCompleteLC() {
        return myAttribute.trim()
            + myOperator.trim()
            + myValue.trim();
    }
    
    public String toString() {
        return getCompleteLC();
    }

}

