////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.MKB;

import java.util.*;

public class PCConstraint implements java.io.Serializable{
  private Relation myR1;
  private Relation myR2;
  private String myExt;
  private Vector myPC_Pairs = new Vector();

  boolean reverse=false;
  public int IterationNum=0;
  public boolean Derived=false;


  public PCConstraint(Relation R1,Relation R2,String Ext){
    // swap R1 and R2
    if(Ext.equals("SUPERSET")){
      myR1=R2;
      myR2=R1;
      myExt = "<=";
      reverse=true;
    }
    else{
      myR1=R1;
      myR2=R2;
      if (Ext.equals("SUBSET"))
          myExt= "<=";
      else
          myExt= "=";
    }

  }

  public boolean deletePCConstraint(){
    myR1.deletePCConstraint(this);
    myR2.deletePCConstraint(this);
    return true;
  }

  public boolean Empty(){
    return myPC_Pairs.size()==0;
  }

  public void displayAll(){
    String tempString=new String();

    for(int i=0;i<myPC_Pairs.size();i++)
      tempString=tempString+((PCPair)myPC_Pairs.elementAt(i)).displayAll();

    /*    System.out.println("PCConstraint: "+myR1.getFullName()+myExt+
		       myR2.getFullName()+" "+
		       tempString);
    */
  }

  public String toString() {
    String tempString=new String();

    for(int i=0;i<myPC_Pairs.size();i++)
      tempString=tempString+((PCPair)myPC_Pairs.elementAt(i)).displayAll();
      String s = myR1.getFullName()+myExt+myR2.getFullName()+" "+tempString;
    return myR1.getFullName()+myExt+myR2.getFullName()+" "+tempString;
  }

  public boolean addPair(Vector PCP){
    myPC_Pairs=PCP;
    return true;
  }

  public boolean addPair(Attribute A1,Attribute A2){
    if(reverse)
      myPC_Pairs.addElement(new PCPair(A2,A1));
    else
      myPC_Pairs.addElement(new PCPair(A1,A2));
    return true;
  }

  public Relation getR1() {
    return myR1;
  }

  public Relation getR2() {
    return myR2;
  }

  public String getExtent() {
    return myExt;
  }

  public Vector getPCPairs() {
    return myPC_Pairs;
  }

  public Vector getR1_Attributes() {
    Enumeration e = myPC_Pairs.elements();
    Vector result = new Vector();
    while (e.hasMoreElements()) {
        result.addElement(((PCPair)e.nextElement()).getA1());
    }
    return result;
  }

    public Vector getR2_Attributes() {
    Enumeration e = myPC_Pairs.elements();
    Vector result = new Vector();
    while (e.hasMoreElements()) {
        result.addElement(((PCPair)e.nextElement()).getA2());
    }
    return result;
  }

}

